DROP TABLE tb_endereco CASCADE CONSTRAINTS;
DROP TABLE tb_localizacao CASCADE CONSTRAINTS;
DROP TABLE tb_posto CASCADE CONSTRAINTS;
DROP TABLE tb_ocorrencia CASCADE CONSTRAINTS;
DROP TABLE tb_atendente CASCADE CONSTRAINTS;
DROP TABLE tb_bombeiro CASCADE CONSTRAINTS;
DROP TABLE tb_vitima CASCADE CONSTRAINTS;
DROP TABLE tb_bombeiro_ocorrencia CASCADE CONSTRAINTS;
DROP TABLE tb_notifica CASCADE CONSTRAINTS;

CREATE TABLE tb_endereco OF tp_endereco (
	cep NOT NULL,
	numero NOT NULL
);

CREATE TABLE tb_localizacao OF tp_localizacao (
	ponto_referencia NOT NULL
);

CREATE TABLE tb_posto OF tp_posto (
	codigo PRIMARY KEY,
	endereco WITH ROWID REFERENCES tb_endereco
);

CREATE TABLE tb_ocorrencia OF tp_ocorrencia (
	codigo PRIMARY KEY,
	localizacao WITH ROWID REFERENCES tb_localizacao
);

CREATE TABLE tb_atendente OF tp_atendente (
	cpf PRIMARY KEY,
	guiche NOT NULL
);

CREATE TABLE tb_bombeiro OF tp_bombeiro (
	cpf PRIMARY KEY,
	supervisor WITH ROWID REFERENCES tb_bombeiro,
	posto WITH ROWID REFERENCES tb_posto
);

CREATE TABLE tb_vitima OF tp_vitima (
	cpf PRIMARY KEY,
	codigo NOT NULL,
	obito NOT NULL,
	ocorrencia WITH ROWID REFERENCES tb_ocorrencia
)
NESTED TABLE lista_bombeiro_ocorrencia STORE AS tb_lista_bombeiro_ocorrencia;

CREATE TABLE tb_bombeiro_ocorrencia OF tp_bombeiro_ocorrencia (
	codigo PRIMARY KEY,
	bombeiro WITH ROWID REFERENCES tb_bombeiro,
	ocorrencia WITH ROWID REFERENCES tb_ocorrencia
)
NESTED TABLE lista_vitimas STORE AS tb_lista_vitimas;

CREATE TABLE tb_notifica OF tp_notifica (
	posto WITH ROWID REFERENCES tb_posto,
	ocorrencia WITH ROWID REFERENCES tb_ocorrencia,
	atendente WITH ROWID REFERENCES tb_atendente,
	data NOT NULL
);