DROP TYPE tp_endereco FORCE;
DROP TYPE tp_localizacao FORCE;
DROP TYPE tp_telefone FORCE;
DROP TYPE tp_va_telefone FORCE;
DROP TYPE tp_pessoa FORCE;
DROP TYPE tp_posto FORCE;
DROP TYPE tp_ocorrencia FORCE;
DROP TYPE tp_atendente FORCE;
DROP TYPE tp_bombeiro FORCE;
DROP TYPE tp_bombeiro_ocorrencia FORCE;
DROP TYPE tp_nt_ref_bombeiro_ocorrencia FORCE;
DROP TYPE tp_nt_ref_vitima FORCE;
DROP TYPE tp_vitima FORCE;
DROP TYPE tp_notifica FORCE;

CREATE OR REPLACE TYPE tp_endereco AS OBJECT (
	logradouro VARCHAR2(70),
	numero VARCHAR2(5),
	complemento VARCHAR2(25),
	bairro VARCHAR2(25),
	cidade VARCHAR2(25),
	estado VARCHAR2(2),
	cep VARCHAR2(8)
) NOT FINAL;
/

CREATE OR REPLACE TYPE tp_localizacao UNDER tp_endereco (
	ponto_referencia VARCHAR2(200)
);
/

CREATE OR REPLACE TYPE tp_telefone AS OBJECT(
	numero VARCHAR2(8),
	ddd VARCHAR2(2)
);
/

CREATE OR REPLACE TYPE tp_va_telefone AS VARRAY(5) OF tp_telefone;
/

CREATE OR REPLACE TYPE tp_pessoa AS OBJECT (
	nome VARCHAR2(40),
	data_nascimento DATE,
	sexo CHAR,
	cpf VARCHAR2(11),
	telefones tp_va_telefone
) NOT FINAL NOT INSTANTIABLE;
/

CREATE OR REPLACE TYPE tp_posto AS OBJECT (
	codigo VARCHAR2(10),
	nome VARCHAR(25),
	endereco REF tp_endereco,
	emblema BLOB
);
/

CREATE OR REPLACE TYPE tp_ocorrencia AS OBJECT (
	codigo VARCHAR2(10),
	tipo NUMBER,
	nome_solicitante VARCHAR2(40),
	localizacao REF tp_localizacao
);
/

CREATE OR REPLACE TYPE tp_atendente UNDER tp_pessoa (
	guiche NUMBER
);
/

CREATE OR REPLACE TYPE tp_bombeiro UNDER tp_pessoa (
	cargo VARCHAR2(20),
	supervisor REF tp_bombeiro,
	posto REF tp_posto
);
/

CREATE OR REPLACE TYPE tp_bombeiro_ocorrencia;
/

CREATE OR REPLACE TYPE tp_nt_ref_bombeiro_ocorrencia AS TABLE OF REF tp_bombeiro_ocorrencia;
/

CREATE OR REPLACE TYPE tp_vitima UNDER tp_pessoa (
	codigo VARCHAR2(10),
	obito CHAR,
	diagnostico VARCHAR2(50),
	hospital_destino VARCHAR2(50),
	ocorrencia REF tp_ocorrencia,
	lista_bombeiro_ocorrencia tp_nt_ref_bombeiro_ocorrencia
);
/

CREATE OR REPLACE TYPE tp_nt_ref_vitima AS TABLE OF REF tp_vitima;
/

CREATE OR REPLACE TYPE tp_bombeiro_ocorrencia AS OBJECT (
	codigo NUMBER,
	bombeiro REF tp_bombeiro,
	ocorrencia REF tp_ocorrencia,
	lista_vitimas tp_nt_ref_vitima
);
/

CREATE OR REPLACE TYPE tp_notifica AS OBJECT (
	posto REF tp_posto,
	ocorrencia REF tp_ocorrencia,
	atendente REF tp_atendente,
	data DATE
);
/